'ATA Test By Phil

Config Clock = Soft , Gosub = Sectic
Config Lcdmode = Bus
Config Lcd = 16 * 4

'hardware addresses
$lcd = &H8001                                               'The address of the LCD WITH RS selected?
$lcdrs = &H8000                                             'The address of the LCD WITHOUT RS selected?

'External Libraries
$lib "lcd8busy.lbx"
$external Lcdtakedata , Lcdtakectrl , Lcd8busy , Lcdread , Lcdreaddata
Declare Function Lcdread() As Byte
$lcdputdata = Lcdtakedata                                   'Redirect lcd data
$lcdputctrl = Lcdtakectrl                                   'Redirect lcd control
Const $lcd = &H8001                                         'lcd address.
Const $lcdrs = &H8000                                       'lcd address.
'Other stuff
$lib "utilities.lbx"
$external Mem2mem , Mod32base2

'ATA driver
$lib "ataonbus.lbx"
$external Get_data , Read_sec , Gotosleep , Initata
'Constants used by Ataonbus.lib
Const Atacs0 = &H8E00                                       'Chip Select 0 of ATA
Const Atacs1 = &H8C00                                       'Chip Select 1 of ATA (only used once to software reset drive)
Const Atahi8 = &H8A00                                       'High 8 bits
Const Atacommand_reg = Atacs0 + 7
Const Atacylinderhigh_reg = Atacs0 + 5                      'write only
Const Atacylinderlow_reg = Atacs0 + 4
Const Atadata_reg = Atacs0                                  'same as atacs0
Const Atadevicecontrol_reg = Atacs1 + 6                     'write only, the only useful thing here is reset, which may not be needed
Const Atadevicehead_reg = Atacs0 + 6
Const Ataerror_reg = Atacs0 + 1                             'read only
Const Atafeatures_reg = Atacs0 + 1                          'write only
Const Atasectorcount_reg = Atacs0 + 2
Const Atasectornumber_reg = Atacs0 + 3
Const Atastatus_reg = Atacs0 + 7                            'read only
Const Ataaltstatus_reg = Atacs1 + 6                         'read only Not used, the same info is in the Atastatus_reg
Const Maxtime = 20                                          'Max Time for drive to complete task (in seconds)
Const Sleeptime = 30                                        'Put drive to sleep after 30 seconds of no reads

$lib "fat32.lbx"
$external Cluster2sector , Next_cluster , Fill_buffer , Sequential , Random_access , Dir_name , Dir_ext , Dir_firstclus , Dir_filesize , Dir_attr
$external Openfile , Initfat32 , Signaturecheck , Parsembr , Parsebpb , Initroot , Flushbuffer , Nextfile , Defaultfilenamedata
$external File2bufferoffset , Xbytesperdirentry , _trim , _flash2ram , _assignzero , Allocateframe , Deallocateframe , _sub32 , _add32 , _len
Declare Sub Random_access(cluster As Long)
Declare Function Dir_name(direntry As Word) As String
Declare Function Dir_ext(direntry As Word) As String
Declare Function Dir_firstclus(direntry As Word) As Long
Declare Function Dir_filesize(direntry As Word) As Long
Declare Function Dir_attr(direntry As Word) As Byte
Declare Sub Openfile(direntry As Word)
Declare Sub Nextfile(direntry As Word , Byval Updown As Byte)
'variables used by fat32.lib
'Some must be dimentioned in specific order, do not swap about
Dim Filebyte As Byte                                        'THE file byte, very busy bit of ram
Dim Bpb_rootclus As Long                                    'Bios Parameter Block Root Cluster. Usually 2
Dim Bpb_secperclus As Byte                                  'Sectors per Cluster. Usually 8. Also referred to as "Allocation Unit"
Dim Dirlbabegin As Long                                     'Dir LBA Begin. Calculated from Fatlbabegin & Bpb_fatz32
Dim Plbabegin As Long                                       'Partition LBA Begin
Dim Bytesperclus As Word                                    'Bytes Per Cluster. Calculated from Bpb_bytespersec & Bpb_secperclus. Usually 4096 (&H1000)
Dim Bpb_resvdseccnt As Byte                                 'Bios Parameter Block Reserved Sector Count.
Dim Bpb_fatz32 As Long                                      'Bios Parameter Block Fat 32 Size (per one FAT table)
Dim Fatlbabegin As Long                                     'FAT LBA Begin. Calculated from Plbabegin & Bpb_resvdseccnt
Dim Filename As String * 13                                 'The most recently opened file or dir
Dim Ticktock As Byte                                        'System clock, goes up by 1 every second, wraps at 255 (4.25min)
Dim Timetosleep As Byte                                     'Contains the system time that the drive is due to sleep.
Dim Filenumber As Word                                      'File (or DIR) number. Base 0
Dim Fileoffset As Long                                      'File (or DIR) byte counter. Base 0

'Next 2 must be in order******
Dim Fatloadedstart As Long                                  'contains the start sector loaded
Dim Fatloadedstop As Long                                   'contains the stop sector loaded
'*****************************
'Next 4 must be in order******
Dim Filecluster As Long                                     'The current file cluster
Dim Endoffile As Byte                                       '&HFF = End Of File
'& If small buffer = the current count of sector iterations
'Or if big buffer = the current count of cluster iterations
Dim Fileclusterindex As Word                                'The current file cluster index
Dim Filefirstcluster As Long                                'The first file cluster of the file
'*****************************
'Next 4 must be in order******
Dim Dircluster As Long                                      'The current dir cluster
Dim Endofdir As Byte                                        '&HFF = End Of Dir
'& If small buffer = the current count of sector iterations
'Or if big buffer = the current count of cluster iterations
Dim Dirclusterindex As Word                                 'The current dir cluster index
Dim Dirfirstcluster As Long                                 'The first dir cluster of the dir
'*****************************
Dim Filesize As Long                                        'The File Size
Dim Fileclustersize As Byte                                 'size of buffer in clusters (if bigger than 1 cluster)
Dim Filenumofit As Byte                                     'if big buffer, number of cluster iterations to fill buffer

'SET BUFFER SIZE HERE
'***************************************************************
'buffer sizes for fat32
'***************************************************************                                                              'If small buffer, the number of sector iterations to fill buffer
Const Filebuffersectorsize = 32                             'MUST be a power of 2 e.g. 1,2,4,8,16...
'The bigger, the better. BUT, it must fit in available ram.
Const Fatbuffersectorsize = 16                              'MUST be a power of 2 eg 1,2,4,8,16...
'The bigger, the better. BUT, it must fit in available ram.

Const Filebuffersize = Filebuffersectorsize * 512
Const Filebuffersize_lo = Filebuffersize And &HFF
Const Filebuffersize_hi =(filebuffersize And &HFF00) / &H100
Dim Filebuffer(filebuffersize) As Xram Byte                 'The place where all the file stuff goes
Const Fatbuffersize = Fatbuffersectorsize * 512
Dim Fatbuffer(fatbuffersize) As Xram Byte                   'The place where all FAT stuff goes

'DIR_Attr masks
Const Attr_read_onlymsk = &H01
Const Attr_hiddenmsk = &H02                                 'Not used
Const Attr_systemmsk = &H04                                 'Not used
Const Attr_volume_idmsk = &H08                              'Not used
Const Attr_directorymsk = &H10
Const Attr_archivemsk = &H20
Const Attr_long_namemsk = &H0F                              'Not used
Const Attr_validmsk = Attr_read_onlymsk Or Attr_systemmsk Or Attr_directorymsk Or Attr_archivemsk
'fatal error codes. Should never see it!
Dim Errorcode As Byte
'1 = Timeout.
'2 = Drive error (bit 0 in status register)
'3 = Expected bytes transferred not equal to actual bytes transferred.
'4 = Bios Parameter Block error.
'5 = Failed Master Boot Record signature check, or Bios Parameter Block signature check.
'6 = Next cluster called while end of file.
'7 = Fill buffer called while end of file.

'Physical constants
Const Bytesperbyte = 1
Const Bytesperword = 2
Const Bytesperlong = 4
Const Lcdcols = 16
Const Lcdrows = 4
Const Greeting = "ATA Test 1.0"
Declare Function Dir_filesizestr(direntry As Word) As String
Declare Sub Dir2lcd(byval Direntry As Word)

Upbutton Alias Pinb.1
Downbutton Alias Pinb.2
Openbutton Alias Pinb.3
Playbutton Alias Pind.2

Dim lTimeStamp as Long
Dim lSecondsElapsed as Long
Dim Temp As Byte                                            'Temp Byte
Dim Tempword As Word                                        'Temp word
Dim Templong As Long                                        'Temp long

'messy solution
Templong = Templong * Templong                              'just here to "install" _mul32 routine from somewhere???
Tempword = Tempword / Tempword                              'just here to "install" _div16 routine from somewhere???
Tempword = Tempword * Tempword                              'just here to "install" _mul16 routine from somewhere???
Temp = Temp / Temp                                          'just here to "install" _div8 routine from somewhere???

'***************************************************************
'Program Start
'***************************************************************
Config Upbutton = Input                                     'config button ports as inputs
Config Downbutton = Input
Config Openbutton = Input
Config Playbutton = Input
Set Portb.1                                                 'enable internal pull up resistors on button ports
Set Portb.2
Set Portb.3
Set Portd.2
Enable Interrupts
Waitms 100                                                  'wait for lcd to do its stuff
Cls
Cursor Off                                                  'turn off annoying cursor
Lcd Greeting                                                'Be polite
Print Greeting                                              'see if the serial port is working
Wait Maxtime                                                'give some time for drive to spin up
Gosub Initata                                               'Software reset drive. No hardware at cs1 ata address, left here just in case
Cls
Gosub Initfat32                                             'Init fat 32 filesystem
Gosub Initroot                                              'Init root directory
Call Dir2lcd(filenumber)                                    'Lets display the DIR

Main:
If Upbutton = 0 Then Goto Up
If Downbutton = 0 Then Goto Down
Debounce Openbutton , 0 , Openafile
'comment in what "play button" is
Debounce Playbutton , 0 , Printafile                        'print a text file
'OR
'Debounce Playbutton , 0 , Printafilebackwards               'print a text file backwards. Why? because I can.
'OR
'Debounce Playbutton , 0 , Moveafile                         'speed test
If Ticktock = Timetosleep Then Gosub Gotosleep              'Put drive to sleep
Goto Main

Up:
Call Nextfile(filenumber , 1)                               'Find next valid file number
Call Dir2lcd(filenumber)                                    'Display dir on lcd
Waitms 100                                                  'no debounce on up button
Goto Main

Down:
Call Nextfile(filenumber , 255)                             'Find previous valid file number
Call Dir2lcd(filenumber)                                    'Display dir on lcd
Waitms 100                                                  'no debounce on down button
Goto Main

Openafile:
Bitwait Openbutton , Set                                    'wait for finger to come off button
Waitms 100
Call Openfile(filenumber)                                   'open the file (or dir)
'Open file sets cluster = first cluster and end of file and cluster index
Call Dir2lcd(filenumber)                                    'Display dir on lcd
Goto Main

Printafile:
Bitwait Playbutton , Set                                    'wait for finger to come off button
Waitms 100
Fileoffset = 0                                              'make fileoffset = 0 otherwise sequemtial does not know to fetch a fresh buffer
Do
   If Playbutton = 0 Then Exit Do
   Gosub Sequential                                         'sequential transfers from buffer to filebyte & increments file offset
'sequential only works on files
   Print Chr(filebyte);                                     'print the file byte
Loop Until Fileoffset >= Filesize
Print
Print "Printed " ; Fileoffset ; " bytes"
Gosub Flushbuffer                                           'Flush the buffer when finished playing with the file
Goto Main

Printafilebackwards:
Bitwait Playbutton , Set                                    'wait for finger to come off button
Waitms 100
For Fileoffset = Filesize To 0 Step -1
   If Playbutton = 0 Then Exit For
   Call Random_access(filecluster)                          'Random access grabs the file byte at file ofset
'since random works on files and directories, must specify either file cluster for files, or dir cluster for directory
   Print Chr(filebyte);                                     'print the file byte
Next Fileoffset
Gosub Flushbuffer                                           'Flush the buffer when finished playing with the file
Goto Main

Moveafile:
Bitwait Playbutton , Set                                    'wait for finger to come off button
Waitms 100
Ltimestamp = Secofday()                                     'Set time stamp
Fileoffset = 0                                              'make fileoffset = 0 otherwise sequemtial does not know to fetch a fresh buffer
Do
   If Playbutton = 0 Then Exit Do
   Gosub Sequential                                         'sequential transfers from buffer to filebyte & increments filebyte
Loop Until Fileoffset >= Filesize
Print
Print "Moved " ; Fileoffset ; " bytes"
Lsecondselapsed = Secelapsed(ltimestamp)                    'calc the elapsed seconds
Print "In " ; Lsecondselapsed ; " seconds"
Lsecondselapsed = Fileoffset / Lsecondselapsed
Print "Transfer rate " ; Lsecondselapsed ; " bytes per second"
'about 120k bytes per second with "If Playbutton = 0 Then Exit Do" in the loop
'about 134k bytes per second without "If Playbutton = 0 Then Exit Do" in the loop
'works out to be 120 cycles to transfer 1 byte from disk to main program
'e.g. 1440 seconds (24min) to move a 194M byte file.
Gosub Flushbuffer                                           'Flush the buffer when finished playing with the file
Goto Main

'***************************************************************
'Dir_filesizestr
'Dir File Size String
'***************************************************************
'returns a string of the File Size, made as small as possible to try to fit all info on a LCD
Function Dir_filesizestr(direntry As Word) As String * 5
Local Attr As Byte , Divider As Long , Suffix As String * 1 , Ctr As Byte , Dirfilesize As Long
Dir_filesizestr = "<DIR>"                                   'set to DIR as default
Attr = Attr_directorymsk And Dir_attr(direntry)
If Attr = Attr_directorymsk Then Exit Function              'if the attribute indicates dir, then exit
Dirfilesize = Dir_filesize(direntry)
Divider = 1000000000                                        'One Gigabyte
Restore Suffix
For Ctr = 1 To 4
   Read Suffix
   If Dirfilesize > Divider Then                            'Is file size bigger than divider
      Dirfilesize = Dirfilesize / Divider                   'then divide by divider
      Dir_filesizestr = Str(dirfilesize) + Suffix           'turn it into a string, and append suffix
      Exit Function                                         'and then bug out.
   End If
   Divider = Divider / 1000                                 'otherwise divide divider by 1000
Next Ctr                                                    'and start again
Dir_filesizestr = "0"                                       'If we got to here, then the file size must have been zero
End Function

Suffix:
Data "G" , "M" , "k" , "B"                                  'Gigabytes, Megabytes, Kilobytes, Bytes


'***************************************************************
'Error Handle
'***************************************************************
Errorhandle:
'Does bugger all. All fatal errors end up here.
'In theory the program should never end up here
'If it does, it may be caused by hardware problems, FAT32 file format problems (run scandisk).
'NEVER by BUGS in my program NEVER NEVER.
Disable Interrupts
Gosub Gotosleep                                             'Just in case drive is alive, put it to sleep
Print ; "Error " ; Errorcode                                'Print some critical values
Print ; "F off " ; Fileoffset
Print ; "Clus " ; Dircluster ; " " ; Filecluster
Print ; "C Idx " ; Fileclusterindex ; " " ; Endoffile

Cls
Lcd "Error " ; Errorcode                                    'Print some critical values on lcd
Locate 2 , 1
Lcd "F off " ; Fileoffset
Locate 3 , 1
Lcd "Clus " ; Filecluster
Locate 4 , 1
Lcd "C Idx " ; Fileclusterindex ; " " ; Endoffile
Do
Loop                                                        'end program
Return                                                      'never return


'***************************************************************
'Second Tick Interrupt Service Routine
'***************************************************************
'Very complex bit of code here
'With NoSave, must save used registers
Sectic:
push r16                                                    'Store r16
in r16, sreg                                                'Status Register to r16
push r16                                                    'Store sreg
lds r16, {ticktock}                                         'Ticktock to r16
inc r16                                                     'Make ticktock a little bigger
sts {ticktock}, r16                                         'and put it back
pop r16                                                     'Get sreg
!Out sreg, r16                                              'Put back Status Register
pop r16                                                     'Get r16
ret                                                         'For use with soft clock
'reti                                                        'Return from interrupt without soft clock

'***************************************************************
'DIR to LCD
'***************************************************************
'Displays the directory on the LCD.
'The first Row is reserved for the current open file (or dir).
'The second row is reserved for the currently selected file (or dir).
Sub Dir2lcd(byval Direntry As Word)
Local Currentrow As Byte
Cls                                                         'Clear lcd & locate 1st row
Lcd Filename                                                'Display last opened file name (or dir)
Currentrow = 2                                              'Second row and down is for dir
Do
   Locate Currentrow , 1                                    'Locate current row
   Lcd Dir_name(direntry) ; Dir_ext(direntry) ; " " ; Dir_filesizestr(direntry)
   'Dir_name = 8, Dir_ext = 4,  " " = 1, Dir_filesizestr = 5. Total, up to 18 characters
   'or
   'Dir_name = 8, dot=1, Dir_ext = 4,  " " = 1, Dir_filesizestr = 5. Total, up to 19 characters
   Incr Currentrow
   Call Nextfile(direntry , 1)
Loop Until Currentrow > Lcdrows
End Sub
