'Wave player By Phil
'References
'Microsoft RIFF Resource Interchange File Format

Config Lcdmode = Bus
Config Lcd = 16 * 4

'hardware addresses
$lcd = &H8001                                               'The address of the LCD WITH RS selected?
$lcdrs = &H8000                                             'The address of the LCD WITHOUT RS selected?

'External Libraries
$lib "lcd8busy.lbx"
$external Lcdtakedata , Lcdtakectrl , Lcd8busy , Lcdread , Lcdreaddata
Declare Function Lcdread() As Byte
$lcdputdata = Lcdtakedata                                   'Redirect lcd data
$lcdputctrl = Lcdtakectrl                                   'Redirect lcd control
Const $lcd = &H8001                                         'lcd address.
Const $lcdrs = &H8000                                       'lcd address.
'Other stuff
$lib "utilities.lbx"
$external Mem2mem , Mod32base2

'ATA driver
$lib "ataonbus.lbx"
$external Get_data , Read_sec , Gotosleep , Initata
'Constants used by Ataonbus.lib
Const Atacs0 = &H8E00                                       'Chip Select 0 of ATA
Const Atacs1 = &H8C00                                       'Chip Select 1 of ATA (only used once to software reset drive)
Const Atahi8 = &H8A00                                       'High 8 bits
Const Atacommand_reg = Atacs0 + 7
Const Atacylinderhigh_reg = Atacs0 + 5                      'write only
Const Atacylinderlow_reg = Atacs0 + 4
Const Atadata_reg = Atacs0                                  'same as atacs0
Const Atadevicecontrol_reg = Atacs1 + 6                     'write only, the only useful thing here is reset, which may not be needed
Const Atadevicehead_reg = Atacs0 + 6
Const Ataerror_reg = Atacs0 + 1                             'read only
Const Atafeatures_reg = Atacs0 + 1                          'write only
Const Atasectorcount_reg = Atacs0 + 2
Const Atasectornumber_reg = Atacs0 + 3
Const Atastatus_reg = Atacs0 + 7                            'read only
Const Ataaltstatus_reg = Atacs1 + 6                         'read only Not used, the same info is in the Atastatus_reg
Const Maxtime = 20                                          'Max Time for drive to complete task (in seconds)
Const Sleeptime = 30                                        'Put drive to sleep after 30 seconds of no reads

$lib "fat32.lbx"
$external Cluster2sector , Next_cluster , Fill_buffer , Sequential , Random_access , Dir_name , Dir_ext , Dir_firstclus , Dir_filesize , Dir_attr
$external Openfile , Initfat32 , Signaturecheck , Parsembr , Parsebpb , Initroot , Flushbuffer , Nextfile , Defaultfilenamedata
$external File2bufferoffset , Xbytesperdirentry , _trim , _flash2ram , _assignzero , Allocateframe , Deallocateframe , _sub32
Declare Sub Random_access(cluster As Long)
Declare Function Dir_name(direntry As Word) As String
Declare Function Dir_ext(direntry As Word) As String
Declare Function Dir_firstclus(direntry As Word) As Long
Declare Function Dir_filesize(direntry As Word) As Long
Declare Function Dir_attr(direntry As Word) As Byte
Declare Sub Openfile(direntry As Word)
Declare Sub Nextfile(direntry As Word , Byval Updown As Byte)
'variables used by fat32.lib
'Some must be dimentioned in specific order, do not swap about
Dim Filebyte As Byte                                        'THE file byte, very busy bit of ram
Dim Bpb_rootclus As Long                                    'Bios Parameter Block Root Cluster. Usually 2
Dim Bpb_secperclus As Byte                                  'Sectors per Cluster. Usually 8. Also referred to as "Allocation Unit"
Dim Dirlbabegin As Long                                     'Dir LBA Begin. Calculated from Fatlbabegin & Bpb_fatz32
Dim Plbabegin As Long                                       'Partition LBA Begin
Dim Bytesperclus As Word                                    'Bytes Per Cluster. Calculated from Bpb_bytespersec & Bpb_secperclus. Usually 4096 (&H1000)
Dim Bpb_resvdseccnt As Byte                                 'Bios Parameter Block Reserved Sector Count.
Dim Bpb_fatz32 As Long                                      'Bios Parameter Block Fat 32 Size (per one FAT table)
Dim Fatlbabegin As Long                                     'FAT LBA Begin. Calculated from Plbabegin & Bpb_resvdseccnt
Dim Filename As String * 13                                 'The most recently opened file or dir
Dim Ticktock As Byte                                        'System clock, goes up by 1 every second, wraps at 255 (4.25min)
Dim Timetosleep As Byte                                     'Contains the system time that the drive is due to sleep.
Dim Filenumber As Word                                      'File (or DIR) number. Base 0
Dim Fileoffset As Long                                      'File (or DIR) byte counter. Base 0

'Next 2 must be in order******
Dim Fatloadedstart As Long                                  'contains the start sector loaded
Dim Fatloadedstop As Long                                   'contains the stop sector loaded
'*****************************
'Next 4 must be in order******
Dim Filecluster As Long                                     'The current file cluster
Dim Endoffile As Byte                                       '&HFF = End Of File
'& If small buffer = the current count of sector iterations
'Or if big buffer = the current count of cluster iterations
Dim Fileclusterindex As Word                                'The current file cluster index
Dim Filefirstcluster As Long                                'The first file cluster of the file
'*****************************
'Next 4 must be in order******
Dim Dircluster As Long                                      'The current dir cluster
Dim Endofdir As Byte                                        '&HFF = End Of Dir
'& If small buffer = the current count of sector iterations
'Or if big buffer = the current count of cluster iterations
Dim Dirclusterindex As Word                                 'The current dir cluster index
Dim Dirfirstcluster As Long                                 'The first dir cluster of the dir
'*****************************
Dim Filesize As Long                                        'The File Size
Dim Fileclustersize As Byte                                 'size of buffer in clusters (if bigger than 1 cluster)
Dim Filenumofit As Byte                                     'if big buffer, number of cluster iterations to fill buffer
                                                            'If small buffer, the number of sector iterations to fill buffer
'SET BUFFER SIZE HERE
'***************************************************************
'buffer sizes for fat32
'***************************************************************
Const Filebuffersectorsize = 32                             'MUST be a power of 2 e.g. 1,2,4,8,16...
'The bigger, the better. BUT, it must fit in available ram.
Const Fatbuffersectorsize = 16                              'MUST be a power of 2 eg 1,2,4,8,16...
'The bigger, the better. BUT, it must fit in available ram.

Const Filebuffersize = Filebuffersectorsize * 512
Const Filebuffersize_lo = Filebuffersize And &HFF
Const Filebuffersize_hi =(filebuffersize And &HFF00) / &H100
Dim Filebuffer(filebuffersize) As Xram Byte                 'The place where all the file stuff goes
Const Fatbuffersize = Fatbuffersectorsize * 512
Dim Fatbuffer(fatbuffersize) As Xram Byte                   'The place where all FAT stuff goes

'DIR_Attr bits
Const Attr_read_onlybit = 0
Const Attr_hiddenbit = 1                                    'Not used
Const Attr_systembit = 3                                    'Not used
Const Attr_volume_idbit = 4                                 'Not used
Const Attr_directorybit = 5
Const Attr_archivebit = 6
Const Attr_long_namebit = 7                                 'Not used

'DIR_Attr masks
Const Attr_read_onlymsk = &H01
Const Attr_hiddenmsk = &H02                                 'Not used
Const Attr_systemmsk = &H04                                 'Not used
Const Attr_volume_idmsk = &H08                              'Not used
Const Attr_directorymsk = &H10
Const Attr_archivemsk = &H20
Const Attr_long_namemsk = &H0F                              'Not used
Const Attr_validmsk = Attr_read_onlymsk Or Attr_systemmsk Or Attr_directorymsk Or Attr_archivemsk
'fatal error codes. Should never see it!
Dim Errorcode As Byte
'1 = Timeout.
'2 = Drive error (bit 0 in status register)
'3 = Expected bytes transferred not equal to actual bytes transferred.
'4 = Bios Parameter Block error.
'5 = Failed Master Boot Record signature check, or Bios Parameter Block signature check.
'6 = Next cluster called while end of file.
'7 = Fill buffer called while end of file.

'Physical constants
Const Bytesperbyte = 1
Const Bytesperword = 2
Const Bytesperlong = 4
Const Lcdcols = 16
Const Lcdrows = 4
Const Greeting = "WAVE player 1.0"

'Wave player stuff
'SET FIFO SIZE HERE
'***************************************************************
'buffer for Wave Player FIFO
'***************************************************************
Const Fifosize = 512
Const Fifosize_lo = Fifosize And &HFF
Const Fifosize_hi =(fifosize And &HFF00) / &H100
'max multiply is the maximum value expected to use a multipling factor of the sample. Values above this means division of the sample.
Const Maxmul = 1 +((_xtal \ 8000) \ 256)                    '1+ ((_xtal / min sample freq) / max sample value @ 8 bit/sample)
'Button assignments
Upbutton Alias Pinb.1
Downbutton Alias Pinb.2
Openbutton Alias Pinb.3
Playbutton Alias Pind.2

Dim Warningcode As Byte
'1 = Not a RIFF file
'2 = Not a WAVE file
'3 = Unsupported format
'4 = no "data" found

Dim Temp As Byte                                            'Temp Byte
Dim Tempword As Word                                        'Temp word
Dim Templong As Long                                        'Temp long

Dim Endofdata As Long
Dim Formattag As Word
Dim Numchannels As Word
Dim Samplespersec As Long
Dim Avgbytespersec As Long
Dim Blockalign As Word
Dim Bitspersample As Word
Dim Fudgefactor As Word

Dim Ch1fifo(fifosize) As Xram Word
Dim Ch2fifo(fifosize) As Xram Word
Dim Putpointer As Word
Dim Takepointer As Word
Dim Fifostatus As Byte


Declare Function Dir_filesizestr(direntry As Word) As String

Declare Function Chunksize(byval Chunkid As String) As Long

Declare Sub Infile(searchstring As String , Byval Maxfileoffset As Long)

Declare Sub Dir2lcd(byval Direntry As Word)

Declare Sub Playwav(direntry As Word)

Declare Sub Flashlcd(byval Row As Byte , Byval Flashtime As Byte , Byval Message As String)

'***************************************************************
'Interrupt Vectors
'***************************************************************
On Timer2 Sectic , Nosave
On Compare1a Newsample , Nosave

'messy solution
Templong = Templong * Templong                              'just here to "install" _mul32 routine from somewhere???
Tempword = Tempword / Tempword                              'just here to "install" _div16 routine from somewhere???
Tempword = Tempword * Tempword                              'just here to "install" _mul16 routine from somewhere???
Temp = Temp / Temp                                          'just here to "install" _div8 routine from somewhere???

'***************************************************************
'Program Start
'***************************************************************
sbi ddrb, 0                                                 'set portb.0 (oc0) as output
sbi ddre, 2                                                 'set porte.2 (oc1b) as an output
sbi ddrb, 4                                                 'set portb.4 (oc3b) as an output
Config Upbutton = Input                                     'config button ports as inputs
Config Downbutton = Input
Config Openbutton = Input
Config Playbutton = Input
Set Portb.1                                                 'enable internal pull up resistors on button ports
Set Portb.2
Set Portb.3
Set Portd.2

'32.768kHz osc on TOSC1 and TOSC prescaled by 128 = 256Hz (1/256seconds). So Tcnt2 (8bit) will wrap every 1 second
'Config Timer2 = Timer , Async = On , Prescale = 1024        'Mass confusion here ???
Assr = &B00001000                                           'AS2: Asynchronous Timer/Counter2 ON
Tccr2 = &B00000101                                          'Mode 0 (normal), clkT2s/128

Enable Timer2                                               'Timer2 is async clock
Enable Interrupts
Waitms 100                                                  'wait for lcd to do its stuff
Cls
Cursor Off                                                  'turn off annoying cursor
Lcd Greeting                                                'Be polite
Print Greeting                                              'see if the serial port is working
Wait Maxtime                                                'give some time for drive to spin up
Gosub Initata                                               'Software reset drive. No hardware at cs1 ata address, left here just in case
Cls
Gosub Initfat32                                             'Init fat 32 filesystem
Gosub Initroot                                              'Init root directory
Call Dir2lcd(filenumber)                                    'Lets display the DIR
Main:
If Upbutton = 0 Then Goto Up
If Downbutton = 0 Then Goto Down
Debounce Openbutton , 0 , Openafile
Debounce Playbutton , 0 , Playafile
If Ticktock = Timetosleep Then Gosub Gotosleep              'Put drive to sleep
Goto Main

Up:
Call Nextfile(filenumber , 1)                               'Find next valid file number
Call Dir2lcd(filenumber)                                    'Display dir on lcd
Waitms 100                                                  'no debounce on up button
Goto Main

Down:
Call Nextfile(filenumber , 255)                             'Find previous valid file number
Call Dir2lcd(filenumber)                                    'Display dir on lcd
Waitms 100                                                  'no debounce on down button
Goto Main

Openafile:
Bitwait Openbutton , Set                                    'wait for finger to come off the open button
Call Openfile(filenumber)                                   'open the file (or dir)
Call Dir2lcd(filenumber)                                    'Display dir on lcd
Goto Main

Playafile:
If Filename <> "<ROOT>" Then                                'make sure a file or dir is open
   Bitwait Playbutton , Set                                 'wait for finger to come off the play button
   Call Playwav(filenumber)
   Gosub Flushbuffer
End If
Goto Main

'***************************************************************
'Flash LCD
'***************************************************************
'Flashes a message on the lcd at the row location for flashtime seconds
Sub Flashlcd(byval Row As Byte , Byval Flashtime As Byte , Byval Message As String)
Local Rowdata As String * Lcdcols , Colcount As Byte , Rowcoldata As Byte
Locate Row , 1                                              'locate at THE row, col 1
For Colcount = 1 To Lcdcols
   Rowcoldata = Lcdread()
   Mid(rowdata , Colcount) = Rowcoldata                     'fill row data with old data
Next Colcount
Locate Row , 1                                              'locate at THE row, col 1
Lcd Message                                                 'display THE message
Colcount = Len(message)
Colcount = Lcdcols - Colcount
Lcd Space(colcount)                                         'Fille the rest of the row with spaces
Wait Flashtime                                              'wait
Locate Row , 1                                              'locate at THE row, col 1
Lcd Rowdata                                                 'restore old data
End Sub

'***************************************************************
'Dir_filesizestr
'Dir File Size String
'***************************************************************
'returns a string of the File Size, made as small as possible to try to fit all info on a LCD
Function Dir_filesizestr(direntry As Word) As String * 5
Local Attr As Byte , Divider As Long , Suffix As String * 1 , Ctr As Byte , Dirfilesize As Long
Dir_filesizestr = "<DIR>"                                   'set to DIR as default
Attr = Attr_directorymsk And Dir_attr(direntry)
If Attr = Attr_directorymsk Then Exit Function              'if the attribute indicates dir, then exit
Dirfilesize = Dir_filesize(direntry)
Divider = 1000000000                                        'One Gigabyte
Restore Suffix
For Ctr = 1 To 4
   Read Suffix
   If Dirfilesize > Divider Then                            'Is file size bigger than divider
      Dirfilesize = Dirfilesize / Divider                   'then divide by divider
      Dir_filesizestr = Str(dirfilesize) + Suffix           'turn it into a string, and append suffix
      Exit Function                                         'and then bug out.
   End If
   Divider = Divider / 1000                                 'otherwise divide divider by 1000
Next Ctr                                                    'and start again
Dir_filesizestr = "0"                                       'If we got to here, then the file size must have been zero
End Function

Suffix:
Data "G" , "M" , "k" , "B"                                  'Gigabytes, Megabytes, Kilobytes, Bytes


'***************************************************************
'Error Handle
'***************************************************************
Errorhandle:
'Does bugger all. All fatal errors end up here.
'In theory the program should never end up here
'If it does, it may be caused by hardware problems, FAT32 file format problems (run scandisk).
'NEVER by BUGS in my program NEVER NEVER.
Disable Interrupts
Gosub Gotosleep                                             'Just in case drive is alive, put it to sleep
Print ; "Error " ; Errorcode                                'Print some critical values
Print ; "F off " ; Fileoffset
Print ; "Clus " ; Dircluster ; " " ; Filecluster
Print ; "C Idx " ; Fileclusterindex ; " " ; Endoffile

Cls
Lcd "Error " ; Errorcode                                    'Print some critical values on lcd
Locate 2 , 1
Lcd "F off " ; Fileoffset
Locate 3 , 1
Lcd "Clus " ; Filecluster
Locate 4 , 1
Lcd "C Idx " ; Fileclusterindex ; " " ; Endoffile
Do
Loop                                                        'end program
Return                                                      'never return


'***************************************************************
'Second Tick Interrupt Service Routine
'***************************************************************
'Very complex bit of code here
'With NoSave, must save used registers
Sectic:
push r16                                                    'Store r16
in r16, sreg                                                'Status Register to r16
push r16                                                    'Store sreg
lds r16, {ticktock}                                         'Ticktock to r16
inc r16                                                     'Make ticktock a little bigger
sts {ticktock}, r16                                         'and put it back
pop r16                                                     'Get sreg
!Out sreg, r16                                              'Put back Status Register
pop r16                                                     'Get r16
'ret                                                         'For use with soft clock
reti                                                        'Return from interrupt without soft clock


'***************************************************************
'Chunk Size
'***************************************************************
'Searches a file for the Chunk ID and returns its size.
'If found, the warning code is set to zero to indicate success, or warning code is left unchanged to indicate failure
Function Chunksize(byval Chunkid As String) As Long
Local Cnt As Byte , Bufferoffset As Word
Call Infile(chunkid , 100)
If Warningcode <> 0 Then
   Chunksize = 0
   Exit Function
End If
Bufferoffset = Fileoffset Mod Filebuffersize
Loadadr Filebuffer(bufferoffset + 1) , X
Loadadr Chunksize , Z
ldi r21, bytesperlong
!call mem2mem
End Function


'***************************************************************
'In File
'***************************************************************
'File must be opened first & File offset MUST be set before the expected characters.
'Searches for a string in a file starting from the current file offset.
'Returns the file offset at the end of the string.
'If found, the warning code is set to zero to indicate success
'So if the file offset of the start of string is needed, then subtract the length of the search string.
'If the search string is not found before max file offset, then warning code is left unchanged to indicate failure
Sub Infile(searchstring As String , Byval Maxfileoffset As Long)
Local Offset As Byte , Searchchr As String * 1
Offset = 1                                                  'Lets start at offset 1 of the search string
Do
   Searchchr = Mid(searchstring , Offset , 1)               'Assign search character
   Gosub Sequential                                         'Assign search byte
   If Searchchr = Filebyte Then
      If Offset = Len(searchstring) Then                    'Check to see if we are done
         Warningcode = 0                                    'Then clear warning
         Exit Do                                            'And bug out
      End If
      Incr Offset                                           'Next search character
   Else
      If Fileoffset > Maxfileoffset Then Exit Do            'if time to give up then bug out
   Offset = 1                                               'Start searching at offset 1 again
   End If
Loop
End Sub


'***************************************************************
'DIR to LCD
'***************************************************************
'Displays the directory on the LCD.
'The first Row is reserved for the current open file (or dir).
'The second row is reserved for the currently selected file (or dir).
Sub Dir2lcd(byval Direntry As Word)
Local Currentrow As Byte
Cls                                                         'Clear lcd & locate 1st row
Lcd Filename                                                'Display last opened file name (or dir)
Currentrow = 2                                              'Second row and down is for dir
Do
   Locate Currentrow , 1                                    'Locate current row
   Lcd Dir_name(direntry) ; Dir_ext(direntry) ; " " ; Dir_filesizestr(direntry)
   'Dir_name = 8, Dir_ext = 4,  " " = 1, Dir_filesizestr = 5. Total, up to 18 characters
   'or
   'Dir_name = 8, dot=1, Dir_ext = 4,  " " = 1, Dir_filesizestr = 5. Total, up to 19 characters
   Incr Currentrow
   Call Nextfile(direntry , 1)
Loop Until Currentrow > Lcdrows
End Sub

'***************************************************************
'Play a Wave file
'***************************************************************
'parses the wav file, sets up PWM on counter 1 and 3, generates 50X sample rate clock on counter 0, and plays wav file
'If playing a single wav, bugs out if not a compatible wav format
'If playing a dir, skips it, and gets the next.
'Flashes a message on the LCD if something is wrong.
Sub Playwav(direntry As Word)
Local Lcdtime As Byte , Attr As Byte
Attr = Dir_attr(direntry)                                   'get the attribute of the directory entry
Attr = Attr And Attr_directorymsk                           'mask off all but the directory bit
Do
   If Playbutton = 0 Then
      Attr = 0
      Goto Playwavend                                       'don't like the song or dir, bug out
   End If
   If Attr = Attr_directorymsk Then
      'we are playing a whole dir
      Do
         Call Nextfile(direntry , 1)                        'get next valid file
         If Direntry = 0 Then                               'if next file returns zero then we have wraped
            Call Dir2lcd(direntry)                          'display dir on lcd, for the last time
            Exit Sub                                        'and bug out
         End If
      Loop Until Dir_ext(direntry) = "WAV"                  'find a WAV file
      Call Openfile(direntry)                               'open the file
      Call Dir2lcd(direntry)                                'display dir on lcd
   Else
      'we are playing one dir entry
      If Dir_ext(direntry) <> "WAV" Then                    'make sure it is a WAV file
         Call Flashlcd(1 , 1 , "not a WAV")
         Exit Sub
      End If
   End If
   Fileoffset = 0                                           'finished playing with directories, set file offset to zero
   Gosub Parsewav                                           'check out the wav file and pull out format info
   If Warningcode > 0 Then                                  'If parsewav cannot find format info,
      Print "WAV error" ; Warningcode                       'display warning on serial port for fun
      Call Flashlcd(1 , 1 , "WAV error")
      Goto Playwavend                                       'then bug out
   End If
   If Formattag <> 1 Then                                   'if Formattag is not 1 (uncompressed raw pcm)
      Call Flashlcd(1 , 1 , "Unsupported WAV")
      Goto Playwavend                                       'then bug out
   End If
   Endofdata = Endofdata + Fileoffset                       'End of WAV data = current file offset + bytesperlong
   Endofdata = Endofdata + Bytesperlong
'Counter 1 & 3 are used as a PWM Digital to Analogue converter
   'Set up counter1 Timer Counter Control 1A & 1B
   'Compare Output Mode counter 1 B = clear on compare. Page 127
   Tccr1a = &B00100011
   'Waveform Generation Mode = 15, TOP = OCR1A, update of OCR1B at TOP, TOV1 flag on TOP. Page 129
   Tccr1b = &B00011001
   Samplespersec = _xtal / Samplespersec
   Decr Samplespersec
   Compare1a = Samplespersec                                'Set TOP Counter1
   'Set up counter3 Timer Counter Control 3A & 3B
   'Compare Output Mode counter 3 B = clear on compare. Page 127
   Tccr3a = &B00100011
   'Waveform Generation Mode = 15, TOP = OCR3A, update of OCR3B at TOP, TOV3 flag on TOP. Page 129
   Tccr3b = &B00011001
   Compare3a = Samplespersec                                'Set TOP Counter3
'Fudge factor is a multiply if we are doing 8 bit or divide if 16 bit.
'In 8 bit WAV uses more of the available range of the compare register.
'In 16 bit WAV makes sure the compare register is less than TOP by chopping off the LSBs.
   Fudgefactor = Samplespersec / &H00FF                     'by default
   If Bitspersample = 16 Then Fudgefactor = &HFFFF / Samplespersec       'bad
   'If Bitspersample = 16 Then Fudgefactor = &H8FFF / Samplespersec       'better
   'If Bitspersample = 16 Then Fudgefactor = &H4FFF / Samplespersec       'best of bad bunch
   'If Bitspersample = 16 Then Fudgefactor = &H2FFF / Samplespersec       'clips peaks
'Counter 0 is used to generate a 50 X sample rate square wave (1:1 mark:space ratio) clock for switched cap filter.
   'set up counter0 Timer Counter Control 0
   'Clear Timer on Compare Match (CTC) Waveform Generation Mode 2. Page 99
   'Toggle OC0 on Compare Match. Page 100
   'clkI/O/(No prescaling). Page 101
   Tccr0 = &B00011001
   Incr Samplespersec
   Samplespersec = Samplespersec / 100                      '50X and another 2X because we are using toggle on match
   Decr Samplespersec
   Ocr0 = Samplespersec
   Putpointer = 0                                           'Initialise fifo control
   Takepointer = 0
   Fifostatus = 0
   Counter1 = 0                                             'Sync counters, as they are running in parallel
   Counter3 = 0
   Gosub Fillfifo                                           'Give the fifo a head start
   'Set up interrupt on counter1
   in r16, timsk                                            'Read Timer Interrupt Mask
   ori r16, &B01000000                                      'Set OCIE1A: Timer/Counter1, Output Compare A Match Interrupt Enable
   !out timsk, r16                                          'Put it back.
   'Interrupt is a go
   'Lets play
   Lcdtime = Ticktock + 1                                   'time for lcd to display something
   Do
      Gosub Fillfifo
      If Lcdtime = Ticktock Then
         Locate 1 , 13                                      'play position
         Lcdtime = Ticktock + 1                             'update lcd time
         If Ticktock.0 = 1 Then                             'On even second
            Lcd "Play"
         Else                                               'On odd second
            Lcd "    "
         End If
      End If
      If Playbutton = 0 Then
         Attr = 0
         Goto Playwavend                                    'don't like the song or dir, bug out
      End If
   Loop Until Fileoffset >= Endofdata                       'If we do not have any more data, then bug out
   'Finished Playing Wav File, but there are still a few bytes left in the fifo
   While Fifostatus <> 0
   'hang around
   Wend
   Playwavend:
   in r16, timsk                                            'Read Timer Interrupt Mask
   andi r16, &B10111111                                     'Clear OCIE1A: Timer/Counter1, Output Compare A Match Interrupt Enable
   !out timsk, r16                                          'Put it back
   'Interrupt is a NO go
   Tccr1a = 0                                               'Timer Counter Control 1A = off
   Tccr3a = 0                                               'Timer Counter Control 3A = off
   Tccr0 = 0                                                'Timer Counter Control 0 = off
   Locate 1 , 13
   Lcd "    "

   Gosub Flushbuffer
   Bitwait Playbutton , Set                                 'wait for finger to come off the play button
Loop Until Attr <> Attr_directorymsk                        'loop if we are playing a dir
End Sub

Parsewav:
Warningcode = 1
Endofdata = Chunksize( "RIFF")                              'Borrow End of Data, as it is not need yet
If Warningcode <> 0 Then Return

Warningcode = 2
Endofdata = Chunksize( "WAVE")                              'Borrow End of Data, as it is not need yet
If Warningcode <> 0 Then Return

Warningcode = 3
Endofdata = Chunksize( "fmt " )                             'Borrow End of Data, as it is not need yet
If Warningcode <> 0 Then Return

Loadadr Filebuffer(21) , X                                  'Source address
Loadadr Formattag , Z                                       'Destination address
ldi r21, bytesperword                                       'Number of bytes to xfer
!Call Mem2mem                                               'Transfer memory to memory

Loadadr Filebuffer(23) , X
Loadadr Numchannels , Z                                     'Destination address
ldi r21, bytesperword                                       'Number of bytes to xfer
!Call Mem2mem                                               'Transfer memory to memory

Loadadr Filebuffer(25) , X
Loadadr Samplespersec , Z                                   'Destination address
ldi r21, bytesperlong                                       'Number of bytes to xfer
!Call Mem2mem                                               'Transfer memory to memory

Loadadr Filebuffer(29) , X
Loadadr Avgbytespersec , Z                                  'Destination address
ldi r21, bytesperlong                                       'Number of bytes to xfer
!Call Mem2mem                                               'Transfer memory to memory
'Print "AvgBytesPerSec " ; Avgbytespersec

Loadadr Filebuffer(33) , X
Loadadr Blockalign , Z                                      'Destination address
ldi r21, bytesperword                                       'Number of bytes to xfer
!Call Mem2mem                                               'Transfer memory to memory
'Print "blkalg " ; Blockalign

Loadadr Filebuffer(35) , X
Loadadr Bitspersample , Z                                   'Destination address
ldi r21, bytesperlong                                       'Number of bytes to xfer
!Call Mem2mem                                               'Transfer memory to memory

Warningcode = 4
Endofdata = Chunksize( "data" )

Return

Fillfifo:
'written in ASM since this must be done as fast as possible.
'with 16000 samples per sec & 8 bits per channel & 2 channels, we have to move 32000 bytes per sec
'22.050ks/s & 16b/ch & 2 ch => 88kB/s which is about the limit.
'why fifo > 255 bytes? (= word pointers)
'It takes about 11ms (measured) to fill the 32k file buffer, so we must buffer at least 11ms worth of sound per channel.
'At 16ks/s = a buffer size of about 176. BUT if a fresh fat has to be loaded, it may take >30ms
'so a fifo > 500 is needed (= word pointers).
lds r16, {fifostatus}
cpi r16, &HFF
brne fillfifofill                                           'While fifo not full, fill it
ret                                                         'RETURN is here
Fillfifofill:
rcall Getsample                                             'comes back with fudged ch word in r16-r17
push r16
push r17                                                    'save just in case we have 2 channels
lds r18, {Numchannels}
cpi r18, 2                                                  'if we have 2 channels
brne fillfifomono                                           'skip getting ch2 byte
rcall Getsample                                             'comes back with fudged ch word in r16-r17
Fillfifomono:
mov r20, r16
mov r21, r17                                                'copy Ch2 word, in either case
pop r17
pop r16                                                     'pop Ch1 word in either case
lds r24, {putpointer}
lds r25, {putpointer+1}                                     'put pointer to r24-r25
adiw r24, 1                                                 'incument put pointer
ldi r18, fifosize_lo
ldi r19, fifosize_hi
cp r18, r24
cpc r19, r25                                                'compare with fifo size
brne fillfifonowrap
clr r24
clr r25                                                     'If we have reached end, then wrap
Fillfifonowrap:
lsl r24
rol r25                                                     'multiply by bytes per word (2) since the fifo contains words
Loadadr Ch1fifo(1) , X
add r26, r24
adc r27, r25                                                'add pointer to fifo address
st X+, r16                                                  'Store Ch1 lo
st X, r17                                                   'Store Ch2 hi
Loadadr Ch2fifo(1) , X
add r26, r24
adc r27, r25                                                'add pointer to fifo address
st X+, r20                                                  'Store Ch2 lo
st X, r21                                                   'store Ch2 hi
'Check For Full
lsr r25
ror r24                                                     'divide pointer by bytes per word (2)
sts {putpointer}, r24
sts {putpointer+1}, r25                                     'Store pointer
adiw r24, 1                                                 'incument put pointer again
'Fifo size still in r18-r19
cp r18, r24
cpc r19, r25                                                'compare with fifo size again
brne fillfifonowrap1
clr r24
clr r25
Fillfifonowrap1:
lds r18,{takepointer}
lds r19, {takepointer+1}                                    'Take pointer to r16-r17
cp r24, r18
cpc r25, r19                                                'compare take pointer with put pointer
ldi r16, 1                                                  'fifo not full
brne fillfifoend
ldi r16, &HFF                                               'fifo full indication
Fillfifoend:
sts {fifostatus}, r16
rjmp fillfifo

Getsample:
!call Sequential                                            'get lo byte, in r16
push r16                                                    'push lo byte, just in case we have 16 bit resolution
clr r17                                                     'clear hi byte, just in case we have 8 bit resolution
lds r18, {Bitspersample}
cpi r18, 16
brne getsampleskip16bit                                     'if we have 8 bit resolution, skip getting another byte
!call Sequential                                            'get hi byte, in r16
mov r17, r16                                                'move hi byte to lo byte
Getsampleskip16bit:
pop r16                                                     'pop lo byte in either case
'r16-r17 contain the 16 bit sample or 8 bit sample with hi byte = 0
lds r20, {Fudgefactor}
cpi r20, maxmul
brlt getsamplemulsample
ldi r21, &HFF                                               'bias for +ve values lo OR
ldi r22, &H7F                                               'xor mask for -ve values (complement) hi
sbrs r17, 7
rjmp Getsamplepos
'16 bit samples are in twos complement form
eor r16, r21                                                'complement lo
eor r17, r22                                                'complement hi
subi r16, 1*-1                                              'add 1
sbci r17, 1*-1                                              'turn into unsigined 16 bit
Getsampledivneg:                                            'Dodgy fast divide
lsr r17                                                     'shift right (divide by 2)
ror r16                                                     'rotate right thu carry (divide by 2)
lsr r20                                                     'shift fudge factor right
brne Getsampledivneg                                        'till fudge factor = 0
ret
Getsamplepos:
!sub r21, r16                                               'subtract from bias lo
sbc r22, r17                                                'subtract from bias hi
mov r16, r21
mov r17, r22
Getsampledivpos:                                            'Dodgy fast divide
lsr r17                                                     'shift right (divide by 2)
ror r16                                                     'rotate right thu carry (divide by 2)
lsr r20                                                     'shift fudge factor right
brne Getsampledivpos                                        'till fudge factor = 0
ret
Getsamplemulsample:
'Multiply 8 bit sample to get more volume
mul r16, r20                                                'multiply sample by fudge factor
mov r16, r0
mov r17, r1
ret


'***************************************************************
'New Sample Interrupt Service Routine
'***************************************************************
'Sticks a new sample into the Pulse Width Modulator compare registers, from fifos
'Updates take pointer and fifo status.
'This is called by interrupt, so all registers must stay un corrupted.
'With NoSave, must save used registers
Newsample:
push r16
in r16, sreg
push r16
push r17
push r18
push r24
push r25
push r26
push r27                                                    'Save used registers
lds r24, {takepointer}
lds r25, {takepointer+1}                                    'get take pointer
lsl r24
rol r25                                                     'multiply by bytes per word (2) since the fifo contains words
Loadadr Ch1fifo(1) , X
add r26, r24
adc r27, r25                                                'add takepointer to address
ld r16, X+                                                  'get the pwm lo byte
ld r17, X                                                   'get the pwm hi
!out ocr1bh, r17                                            'High register first for this 16 bit register, refer page 108
!out ocr1bl, r16                                            'Lo register next. The CH1fifo(takepointer) byte
Loadadr Ch2fifo(1) , X
add r26, r24
adc r27, r25                                                'add takepointer to address
ld r16, X+                                                  'get the pwm lo byte
ld r17, X                                                   'get the pwm hi
'Warning ocr3b outside "out" address range, use "sts" instead
sts Ocr3bh, r17                                             'High register first for this 16 bit register, refer page 108
sts Ocr3bl, r16                                             'Lo register next. The CH1fifo(takepointer) byte
lsr r25
ror r24                                                     'divide pointer by bytes per word (2)
adiw r24, 1                                                 'incrument takepointer
ldi r16, fifosize_lo
ldi r17, fifosize_hi
cp r24, r16
cpc r25, r17                                                'compare with fifosize
brne newsamplenowrap
clr r24                                                     'if we have reached fifo size, set takepointer back to 0
clr r25
Newsamplenowrap:
lds r16, {putpointer}
lds r17, {putpointer+1}                                     'put pointer to r16-r17
cp r16 , r24
cpc r17, r25                                                'compare take pointer and put pointer
ldi r18, 0                                                  'empty status and / or under run
breq newsamplenoupdateptr                                   'on next sample use the same PWM word if take pointer and put pointer are equal
ldi r18, 1                                                  'not full status. We just took a byte, so it is not full.
sts {takepointer}, r24
sts {takepointer+1}, r25                                    'Save new takepointer if no under run
Newsamplenoupdateptr:
sts {fifostatus}, r18                                       'Update fifo status 0 = fifo empty, 1= not full
pop r27                                                     'Restore used registers
pop r26
pop r25
pop r24
pop r18
pop r17
pop r16
!Out Sreg, r16
pop r16
reti